
public class Huffman {
	  public static int[] findFreqs(String s) {
		  int[] freqs = new int[256];
		  for(int i = 0; i < s.length(); i++) {
			  freqs[(int) s.charAt(i)] += 1;
		  }
		  return freqs;
	  }
	  public static void insertTree(java.util.Vector<BinaryTree> vec, BinaryTree newElement) {
		  boolean flag = false;
		  for(int i = 0; i < vec.size(); i++) {
			  if (newElement.freq < vec.elementAt(i).freq) {
				  vec.insertElementAt(newElement, i);
				  flag = true;
				  break;
			  }
		  }
		  if (!flag) vec.addElement(newElement);
	  }
	  public static BinaryTree buildTree(int[] freqs) {
		  java.util.Vector<BinaryTree> vec = new java.util.Vector<BinaryTree>(256);
		  for(int i = 0; i < 256; i++) {
			  if (freqs[i] == 0) continue;
			  BinaryTree newElement = new BinaryTree((char) i, freqs[i]);
			  insertTree(vec, newElement);
		  }
		  while (vec.size() > 1) {
			  BinaryTree firstElement = vec.firstElement(); vec.remove(0);
			  BinaryTree secondElement = vec.firstElement(); vec.remove(0);
			  BinaryTree newElement = new BinaryTree(firstElement, secondElement);
			  insertTree(vec, newElement);
		  }
		  return vec.firstElement();
	  }
	  public static void main(String[] _) {
		  String s = "a box of biscuits a box of mixed biscuits and a biscuit mixer";
		  int[] freqs = findFreqs(s);
		  BinaryTree tree = buildTree(freqs);
		  tree.print();
	  }
}
